"""autogenerated by genpy from ethercat_hardware/RawFTData.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ethercat_hardware.msg

class RawFTData(genpy.Message):
  _md5sum = "85f5ed45095367bfb8fb2e57954c0b89"
  _type = "ethercat_hardware/RawFTData"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Raw Data from WG035 F/T input via WG006 (gripper MCB).
RawFTDataSample[] samples  # The realtime loop receives upto 4 new samples each 1hKhz cycle 
int64 sample_count         # Counts number of samples
int64 missed_samples       # Counts number of samples that were missed
================================================================================
MSG: ethercat_hardware/RawFTDataSample
# One raw Data sample from WG035 F/T input via WG006 (gripper MCB).
uint64  sample_count
int16[] data
uint16  vhalf
"""
  __slots__ = ['samples','sample_count','missed_samples']
  _slot_types = ['ethercat_hardware/RawFTDataSample[]','int64','int64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       samples,sample_count,missed_samples

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RawFTData, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.samples is None:
        self.samples = []
      if self.sample_count is None:
        self.sample_count = 0
      if self.missed_samples is None:
        self.missed_samples = 0
    else:
      self.samples = []
      self.sample_count = 0
      self.missed_samples = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.samples)
      buff.write(_struct_I.pack(length))
      for val1 in self.samples:
        buff.write(_struct_Q.pack(val1.sample_count))
        length = len(val1.data)
        buff.write(_struct_I.pack(length))
        pattern = '<%sh'%length
        buff.write(struct.pack(pattern, *val1.data))
        buff.write(_struct_H.pack(val1.vhalf))
      _x = self
      buff.write(_struct_2q.pack(_x.sample_count, _x.missed_samples))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.samples is None:
        self.samples = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.samples = []
      for i in range(0, length):
        val1 = ethercat_hardware.msg.RawFTDataSample()
        start = end
        end += 8
        (val1.sample_count,) = _struct_Q.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sh'%length
        start = end
        end += struct.calcsize(pattern)
        val1.data = struct.unpack(pattern, str[start:end])
        start = end
        end += 2
        (val1.vhalf,) = _struct_H.unpack(str[start:end])
        self.samples.append(val1)
      _x = self
      start = end
      end += 16
      (_x.sample_count, _x.missed_samples,) = _struct_2q.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.samples)
      buff.write(_struct_I.pack(length))
      for val1 in self.samples:
        buff.write(_struct_Q.pack(val1.sample_count))
        length = len(val1.data)
        buff.write(_struct_I.pack(length))
        pattern = '<%sh'%length
        buff.write(val1.data.tostring())
        buff.write(_struct_H.pack(val1.vhalf))
      _x = self
      buff.write(_struct_2q.pack(_x.sample_count, _x.missed_samples))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.samples is None:
        self.samples = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.samples = []
      for i in range(0, length):
        val1 = ethercat_hardware.msg.RawFTDataSample()
        start = end
        end += 8
        (val1.sample_count,) = _struct_Q.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sh'%length
        start = end
        end += struct.calcsize(pattern)
        val1.data = numpy.frombuffer(str[start:end], dtype=numpy.int16, count=length)
        start = end
        end += 2
        (val1.vhalf,) = _struct_H.unpack(str[start:end])
        self.samples.append(val1)
      _x = self
      start = end
      end += 16
      (_x.sample_count, _x.missed_samples,) = _struct_2q.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_Q = struct.Struct("<Q")
_struct_H = struct.Struct("<H")
_struct_2q = struct.Struct("<2q")
